



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>并发情况下synchronized死锁</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">并发情况下synchronized死锁</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 22:02:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>存在缺陷的代码：</p>
<pre class="prettyprint linenums">public class DataPropertyIdAndNameRepositoryImpl{<br />
    /** 发布标志 */<br />
    private volatile boolean                      publishFlag;

    public Integer getStandardId(int dataId, String propertyName) {<br />
        if (!publishFlag) {<br />
            loadToCache();<br />
        }<br />
        Integer standardId = 0;<br />
        Map&lt;String, Integer&gt; propertyIdMap = propertyIdLocalCache.get(dataId);<br />
        if (propertyIdMap != null) {<br />
            standardId = propertyIdMap.get(propertyName);<br />
        }<br />
        return standardId;<br />
    }

    public synchronized boolean loadToCache() {<br />
        try {<br />
            DataPropertyIdAndName dataPropertyIdAndName = dataPropertyIdAndNameService<br />
                .queryDataPropertyIdAndName();<br />
            publishFlag = true;<br />
        } catch (Exception e) {<br />
            publishFlag = false;<br />
        }<br />
        return publishFlag;<br />
    }<br />
}
</pre>
<p>存在缺陷的流程：</p>
<p>a. 绿色表示第一个线程，蓝色表示第二个线程。</p>
<p>b. 黄色模块的代码为synchronized标记的代码，并发情况下只会有一个线程执行此方法。</p>
<p>c. 绿色线程执行到紫色模块时，蓝色线程等待进入黄色模块。</p>
<p>d. 蓝色线程执行抛异常，导致publishFlag被置为false。</p>
<p>e. 此时再次有线程进入，判断publishFlag仍为false，因此导致重复不断加载loadToCache.</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20130926002203046?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvaWxhb3R1/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<p>修复后的代码：</p>
<pre class="prettyprint linenums">public class DataPropertyIdAndNameRepositoryImpl{<br />
    /** 发布标志 */<br />
    private volatile boolean                      publishFlag;

    public Integer getStandardId(int dataId, String propertyName) {<br />
        if (!publishFlag) {<br />
            loadToCache();<br />
        }<br />
        Integer standardId = 0;<br />
        Map&lt;String, Integer&gt; propertyIdMap = propertyIdLocalCache.get(dataId);<br />
        if (propertyIdMap != null) {<br />
            standardId = propertyIdMap.get(propertyName);<br />
        }

        return standardId;<br />
    }

    public synchronized boolean loadToCache() {<br />
        try {

            // 双检锁<br />
            if (publishFlag) {<br />
                return publishFlag;<br />
            }

            DataPropertyIdAndName dataPropertyIdAndName = dataPropertyIdAndNameService.queryDataPropertyIdAndName();<br />
            publishFlag = true;

        } catch (Exception e) {<br />
            publishFlag = false;<br />
        }

        return publishFlag;<br />
    }<br />
}
</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxllevq.html">Fragment应用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96kgv4q.html">跨域解决方案二：使用JSONP实现跨域</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g66ylq.html">在 Chrome 中调试 Android 浏览器</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlrwnxq.html">php 学习使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd0lrz8.html">JqGrid TreeView使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zjpo59.html">&lbrack;Java&comma;MVC&rsqb; Eclipse下搭建Spring MVC</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0vy7wq.html">jquery中json数据转换为字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnrp36q.html">Android开发之ContentValues</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1e3kj9.html">install pip3 for python 3&period;x</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv12l2jq.html">关于MyEclipse SVN显示资源历史记录乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kdv069.html">资源向导之 &amp;amp&semi;quot&semi;APUE&amp;amp&semi;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zowgjvq.html">Nginx &plus; Keepalived实现应用高可用负载均衡功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16e4jq.html">&lbrack;转&rsqb;基于&period;NET平台常用的框架整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpwxl69.html">node中间层转发请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1gke5q.html">Linux内核中Makefile、Kconfig和&period;config的关系（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2pvky9.html">Codeforces Round &num;428 &lpar;Div&period; 2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1r3deq.html">Js高设笔记1-2章 defer and async</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4vnpm9.html">webpack报错：Module build failed &lpar;from &period;&sol;node&lowbar;modules&sol;babel-loader&sol;lib&sol;index&period;js&rpar;&colon; Error&colon; Cannot find module &amp;&num;39&semi;babel-preset-env&amp;&num;39&semi; from &amp;&num;39&semi;&period;&period;&period;&amp;&num;39&semi; - Did you mean &amp;quot&semi;&commat;babel&sol;env&amp;quot&semi;&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2oep0q.html">MVC3学习：实现简单的相册管理和图片管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnwmd2q.html">ORACLE 查看分区表分区大小</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlm4wmk9.html">&lbrack;ES6&rsqb; Objects vs Maps</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydk61xq.html">CRT远程连接server字符输出乱码解决一例</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjr7yy9.html">CCSpawn使用CCRepeatForever无效</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydk63dq.html">设计模式（Java版）-创建型模式之简单工厂模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j03dnlq.html">Android模块化编程之引用本地的aar</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1vxrm9.html">C&num;利用ODP&period;NET往oracle中高效插入百万数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd2zx38.html">django&colon; db howto - 1</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnvxkv8.html">C&num;socket通讯两个最经典错误解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xoyez8.html">【nodejs学习】3&period;进程管理及异步编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oek1n9.html">out返回值的用法与用途</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
